\set ECHO all
SET client_encoding = utf8;
SET client_min_messages = notice;

SELECT senna.contains('あいう', senna.to_tsquery('あい'));
SELECT senna.contains('あいう', senna.to_tsquery('いう'));
SELECT senna.contains('あいう', senna.to_tsquery('え'));

SELECT 'あいう' %% 'あい';
SELECT 'あいう' @@ 'あい'::senquery;
SELECT 'あいう' @@ senna.to_tsquery('あい');
SELECT senna.to_tsvector('あいう') @@ senna.to_tsquery('あい');
SELECT senna.to_tsvector('english', 'あいう') @@ senna.to_tsquery('english', 'あい');

SELECT sum(CASE WHEN 'あい1う' %% ('あい' || (i % 4)) THEN 1 ELSE 0 END)  FROM generate_series(1, 1000) t(i);
SELECT sum(CASE WHEN 'あい1う' %% ('あい' || (i % 100)) THEN 1 ELSE 0 END)  FROM generate_series(1, 1000) t(i);

CREATE TABLE tbl (id int4, t text);
INSERT INTO tbl VALUES(1, 'あいう');
INSERT INTO tbl VALUES(2, 'いうえ');
INSERT INTO tbl VALUES(3, 'うえお');

CREATE INDEX idx ON tbl USING senna (t) WITH (initial_n_segments = 2);

SET enable_seqscan = on;
SET enable_indexscan = off;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = on;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = off;
SET enable_bitmapscan = on;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

INSERT INTO tbl VALUES(4, 'あいうえお');
INSERT INTO tbl VALUES(5, 'かきくけこ');

SET enable_seqscan = on;
SET enable_indexscan = off;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = on;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = off;
SET enable_bitmapscan = on;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

UPDATE tbl SET id = 999 WHERE id = 1;
UPDATE tbl SET t = 'さしす' WHERE id = 2;
UPDATE tbl SET t = 'いういう' WHERE id = 3;

SET enable_seqscan = on;
SET enable_indexscan = off;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = on;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = off;
SET enable_bitmapscan = on;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

VACUUM tbl;

SET enable_seqscan = on;
SET enable_indexscan = off;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = on;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = off;
SET enable_bitmapscan = on;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

DELETE FROM tbl WHERE id = 3;

SET client_min_messages = error;
VACUUM FULL tbl;
SET client_min_messages = notice;

SET enable_seqscan = on;
SET enable_indexscan = off;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = on;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = off;
SET enable_bitmapscan = on;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SELECT senna.reindex_index('idx');

SET enable_seqscan = on;
SET enable_indexscan = off;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = on;
SET enable_bitmapscan = off;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SET enable_seqscan = off;
SET enable_indexscan = off;
SET enable_bitmapscan = on;
SELECT * FROM tbl WHERE t %% 'いう' ORDER BY id;

SELECT senna.checkpoint();

SELECT senna.drop_index('idx');

CHECKPOINT;

SELECT * FROM senna.orphan_files;
